SystemOrganization addCategory: #'MC2-Development-Builds'!

MDObject subclass: #MDDistribution
	instanceVariableNames: 'major minor release'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Development-Builds'!

!MDDistribution class methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2009 23:50'!
build
	^ self new build! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:35'!
addPreloadTo: aBuild
	MDFileoutSnapshotsJob new
		path: self releaseDirectory / '0-Preload-Squeak310.st';
		addRepository: self obProject store;
		addSnapshotReference: (self latest: 'OB-Fake');
		addSnapshotReference: (self latest: 'OB-Morphic');
		addSnapshotReference: (self latest: 'OB-Tests-Core');
		addSnapshotReference: (self latest: 'OB-Tests-Morphic');
		addSnapshotReference: (self latest: 'OmniBrowser');
		addToBuild: aBuild! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:18'!
addReleaseFileoutTo: aBuild
	MDFileoutSnapshotsJob new
		path: self releaseDirectory / '1-Monticello2.st';
		addRepository: self mcProject store;
		addSnapshotReference: self releaseReference;
		addToBuild: aBuild! !

!MDDistribution methodsFor: 'paths' stamp: 'cwp 1/19/2009 22:38'!
allReleasesDirectory
	^ self projectDirectory / 'releases'! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:50'!
build
	| target build |
	target := MDTarget with: self buildTarget.
	build := MDBuild new.
	build directory: self allReleasesDirectory.
	target addAllJobsTo: build.
	self addReleaseFileoutTo: build.
	self addPreloadTo: build.
	build runAndWait! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:54'!
buildTarget
	
	^ [:root |
	root directory:
		[:mc |
		mc path: self fullName.
		mc file
			path: '/Users/colin/Projects/Squeak/Monticello2/mc.mcr';
			jobClass: MDCopyFileJob.
		mc directory:
			[:extras |
			extras path: 'extras'.
			extras file
				path: '/Users/colin/Projects/Squeak/scripts/remove-mc1.st';
				jobClass: MDCopyFileJob.
			extras file
				path: '/Users/colin/Projects/Squeak/scripts/remove-mc2.st';
				jobClass: MDCopyFileJob].
		mc directory:
			[:docs |
			docs path: 'docs'.
			docs files
				directoryPath: '/Users/colin/Projects/Squeak/Monticello2/docs';
				pattern: '*.creole';
				jobClass: MDRenderCreoleJob.
			docs file
				path: '/Users/colin/Projects/Squeak/Monticello2/docs/docs.css';
				jobClass: MDCopyFileJob.
			docs directory:
				[:images |
				images path: 'images'.
				images files
					directoryPath: '/Users/colin/Projects/Squeak/Monticello2/docs/images';
					pattern: '*.png';
					jobClass: MDCopyFileJob]]]].! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:37'!
fullName
	^ String streamContents:
		[:out |
		out
			nextPutAll: 'Monticello-';
			print: major;
			nextPut: $.;
			print: minor;
			nextPut: $.;
			print: release]! !

!MDDistribution methodsFor: 'initialize-release' stamp: 'cwp 1/19/2009 23:41'!
guessRelease
	| project memos latest |
	project := self mcProject.
	memos := project store memos select: [ :ea | ea sliceId = self releaseSliceId ].
	latest := self latestMemoFrom: memos.
	^ latest properties ordinal! !

!MDDistribution methodsFor: 'initialize-release' stamp: 'cwp 1/19/2009 22:19'!
initialize
	major := 2.
	minor := 0.
	release := self guessRelease! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:46'!
latest: sliceName
	| project memos |
	project := self obProject.
	memos := project store memos select: [:ea | ea sliceName = sliceName].
	^ (self latestMemoFrom: memos) reference! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 23:41'!
latestMemoFrom: memos 
	^ memos 
		inject: memos anyOne
		into: 
			[ :a :b | 
			a timestamp <= b timestamp 
				ifTrue: [ b ]
				ifFalse: [ a ] ]! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:28'!
major
	^ major! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:28'!
major: anObject
	major := anObject! !

!MDDistribution methodsFor: 'accessing' stamp: 'jf 10/4/2009 18:55'!
mcProject
	^ MDEnvironment default projectWithId: self mcProjectId! !

!MDDistribution methodsFor: 'constants' stamp: 'cwp 1/19/2009 22:22'!
mcProjectId
	^ MDHashstamp fromString: '++++++3nmhINNvaNkCX7nM5KzE3YXTPg'! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:28'!
minor
	^ minor! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:28'!
minor: anObject
	minor := anObject! !

!MDDistribution methodsFor: 'accessing' stamp: 'jf 10/4/2009 18:55'!
obProject
	^ MDEnvironment default projectWithId: self obProjectId! !

!MDDistribution methodsFor: 'constants' stamp: 'cwp 1/19/2009 23:37'!
obProjectId
	^ MDHashstamp fromString: '+++++-6C1POAPzAGKEcJeQXZHRDekgnJ'! !

!MDDistribution methodsFor: 'paths' stamp: 'cwp 1/19/2009 22:38'!
projectDirectory
	^ '/Users/colin/Projects/Squeak/Monticello2' asPath! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 23:14'!
release
	^ release! !

!MDDistribution methodsFor: 'accessing' stamp: 'cwp 1/19/2009 22:28'!
release: anObject
	release := anObject! !

!MDDistribution methodsFor: 'paths' stamp: 'cwp 1/19/2009 22:35'!
releaseDirectory
	^ self allReleasesDirectory / self fullName! !

!MDDistribution methodsFor: 'building' stamp: 'cwp 1/19/2009 23:18'!
releaseReference
	| project memos theMemo |
	project := self mcProject.
	memos := project store memos select: [ :ea | ea sliceId = self releaseSliceId ].
	theMemo := memos detect: [:ea | ea properties ordinal = release].
	^ theMemo reference! !

!MDDistribution methodsFor: 'constants' stamp: 'cwp 1/19/2009 22:24'!
releaseSliceId
	^ MDHashstamp fromString: '+++++2aEBUjj6Qh-YePa0txzw1UYR3xa'! !
